# ---------------------------------------------------------------------------------
# NCPL_EXPORT.pm
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ---------------------------------------------------------------------------------

sub DisplayExportForm
{
	my ($prgscriptname, $server_name, $category, $filetype, $file, $action, $submit, $dbh, $CGISESSID, $debug) = @_;

	my $exportpath = (defined $server_name && $server_name ne '') ? "$PATH_EXPORT/$server_name" : "$PATH_EXPORT";
	
	my $filename   = ($filetype eq "ALL") ? "$exportpath" : "$exportpath/$FILENAMES{$filetype}";
	my $label      = ($filetype eq "ALL") ? "directory:"  : "filename:";
	
	print "<p>Please enter the required data for the export:</p>\n";
	print "<form method=\"POST\" action=\"$prgscriptname\" name=\"exportForm\">\n";
	print "  <input type=\"hidden\" name=\"action\"     size=\"50\" value=\"$action\">\n";
	print "  <input type=\"hidden\" name=\"filetype\"   size=\"50\" value=\"$filetype\">\n";
	print "  <input type=\"hidden\" name=\"CGISESSID\"  size=\"50\" value=\"$CGISESSID\">\n";
	print "  <input type=\"hidden\" name=\"debug\"      size=\"50\" value=\"$debug\">\n";
	print "  <input type=\"hidden\" name=\"exportpath\" size=\"50\" value=\"$exportpath\">\n";
	print "<table>\n";
	html_dbcombobox("server_name", "server_name:", "required", $server_name, $dbh, $SQL_SERVERS, 'onChange="javascript:submitExportForm();"', '', '', 0, $action, $debug);
  html_textbox("category", "category:", "general", 50, $category, '', '', '', 0, $action, $debug);	
  html_textbox("filename", $label, "required", 50, $filename, '', '', '', 0, $action, $debug);
	print "</table>\n";
	print "<p><input type=\"submit\" name=\"submitForm\" value=\"Export\"> <input type=\"reset\" name=\"reset\" value=\"Reset\"></p>\n";
	print "</form>\n";	
}

# ---------------------------------------------------------------------------------

sub initExport {
	my($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug) = @_;
	
	if($submit) 
	{
		print "<p>Exporting ...</p>\n";
		print "<p><IMG SRC=\"../images/running.gif\" HSPACE=\"0\" VSPACE=\"0\" BORDER=\"0\" NAME=\"Progress\" title=\"Please Wait ...\" alt=\"Please Wait ...\"></p>\n";
		if(! -e $exportpath) { 
			print "<p><font color=\"#FFFF00\">WARNING</font> -- Export directory does not exist, directory '$exportpath' created!</p>\n";
			mkdir ($exportpath); 
		}
		my $rv = 1;
		if ( $dbh and $rv ) {
		  if ($action eq "doExportAll") {
		    for(my $i=1;$i<=18;$i++) {
		    	if($i != 4 and $i != 5) {
			      $rv = 1;
			      $rv = export_nagios_cfg_file ($rv, $dbh, "$filename/$FILENAMES{$i}", $i, $server_name, $category, $debug);
			      $rv == 1 ? print "<p><font color=\"#00FF00\">OK</font> -- Export of $table completed!</p>\n" : print "<p><font color=\"#FF0000\">FAILED</font> -- Export of $table failed!</p>\n";
			    }
		    }
		  } else {
		  	 	$rv = export_nagios_cfg_file ($rv, $dbh, $filename, $filetype, $server_name, $category, $debug);
		    	$rv == 1 ? print "<p><font color=\"#00FF00\">OK</font> -- Export of $table completed!</p>\n" : print "<p><font color=\"#FF0000\">FAILED</font> -- Export of $table failed!</p>\n";
		  }
		}
	}
	else 
	{
		DisplayExportForm($prgscriptname, $server_name, $category, $filetype, $filename, $action, $submit, $dbh, $CGISESSID, $debug);           
	}
}

# ---------------------------------------------------------------------------------

sub export_nagios_cfg_file {
  my ($rv, $dbh, $filename, $filetype, $server_name, $category, $debug) = @_;

  my ($blokType, $prefix, $rvOpen, $sql, $sth, $orderby, $whereAnd, $serverAnd);
  
  my (%contacts_inactive, %contactgroups_inactive, %hosts_inactive, %hostgroups_inactive, %misscommands_inactive, %servicegroups_inactive);

	$serverAnd = (defined $server_name and $server_name ne '') ? " server_name=\"$server_name\" and " : ''; 
	
	# Filetype detection
  if ($filetype eq "1") {
    $table    = $TABLE_COMMANDS;
    $orderby  = 'command_name';
    $prefix   = 'command';
    $blokType = 1;
  } elsif ($filetype eq "2") {
  	$table    = $TABLE_CONTACTS;
  	$orderby  = 'contact_name';
  	$prefix   = 'contact';
    $blokType = 2;
  } elsif ($filetype eq "3") {
  	$table    = $TABLE_CONTACTGROUPS;
  	$orderby  = 'contactgroup_name';
  	$prefix   = 'contactgroup';
    $blokType = 3;
  } elsif ($filetype eq "6") {
  	$table    = $TABLE_HOSTS;
    $orderby  = "register asc, host_name";
    $prefix   = 'host';
  	$blokType = 6;
  } elsif ($filetype eq "7") {
  	$table    = $TABLE_HOSTDEPENDENCIES;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_HOSTDEPENDENCIES.host_name and enabled=1)";
  	$orderby  = "host_name";
  	$prefix   = 'hostdependency';
    $blokType = 7;
  } elsif ($filetype eq "8") {
  	$table    = $TABLE_HOSTGROUPESCALATIONS;
  	$whereAnd = "and hostgroup_name=(select hostgroup_name from $TABLE_HOSTGROUPS where $serverAnd hostgroup_name=$TABLE_HOSTGROUPESCALATIONS.hostgroup_name and enabled=1)";
  	$orderby  = "hostgroup_name";
  	$prefix   = 'hostgroupescalation';
    $blokType = 8;
  } elsif ($filetype eq "9") {
  	$table    = $TABLE_HOSTEXTINFO;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_HOSTEXTINFO.host_name and enabled=1) or register=0";
  	$orderby  = "register asc, host_name";
  	$prefix   = 'hostextinfo';
    $blokType = 9;
  } elsif ($filetype eq "10") {
  	$table    = $TABLE_HOSTGROUPS;
  	$orderby  = 'hostgroup_name';
  	$prefix   = 'hostgroup';
  	$blokType = 10;
  } elsif ($filetype eq "11") {
  	$table    = $TABLE_SERVICES;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_SERVICES.host_name and enabled=1) or register=0";
		$orderby  = "register asc, host_name, service_description";
    $prefix   = 'service';
    $blokType = 11;
  } elsif ($filetype eq "12") {
  	$table    = $TABLE_SERVICEDEPENDENCIES;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_SERVICEDEPENDENCIES.host_name and enabled=1) and service_description=(select service_description from $TABLE_SERVICES where $serverAnd host_name=$TABLE_SERVICEDEPENDENCIES.host_name and service_description=$TABLE_SERVICEDEPENDENCIES.service_description and enabled=1)";
  	$orderby  = "host_name, service_description";
  	$prefix   = 'servicedependency';
    $blokType = 12;
  } elsif ($filetype eq "13") {
  	$table    = $TABLE_SERVICEESCALATIONS;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_SERVICEESCALATIONS.host_name and enabled=1) and service_description=(select service_description from $TABLE_SERVICES where $serverAnd host_name=$TABLE_SERVICEESCALATIONS.host_name and service_description=$TABLE_SERVICEESCALATIONS.service_description and enabled=1)";
    $orderby  = "host_name, service_description";
    $prefix   = 'serviceescalation';
    $blokType = 13;
  } elsif ($filetype eq "14") {
  	$table    = $TABLE_SERVICEEXTINFO;
  	$whereAnd = "and host_name=(select host_name from $TABLE_HOSTS where $serverAnd host_name=$TABLE_SERVICEEXTINFO.host_name and enabled=1) and service_description=(select service_description from $TABLE_SERVICES where $serverAnd host_name=$TABLE_SERVICEEXTINFO.host_name and service_description=$TABLE_SERVICEEXTINFO.service_description and enabled=1)";
  	$orderby  = "host_name";
  	$prefix   = 'serviceextinfo';
    $blokType = 14;
  } elsif ($filetype eq "15") {
  	$table    = $TABLE_SERVICEGROUPS;
    $orderby  = 'servicegroup_name';
    $prefix   = 'servicegroup';
    $blokType = 15;
  } elsif ($filetype eq "16") {
  	$table    = $TABLE_TIMEPERIODS;
  	$orderby  = 'timeperiod_name';
  	$prefix   = 'timeperiod';
    $blokType = 16;
  } elsif ($filetype eq "17") {
    $table    = $TABLE_MISCCOMMANDS;
    $orderby  = 'command_name';
    $prefix   = 'command';
    $blokType = 1;    
  } elsif ($filetype eq "18") {
  	$table    = $TABLE_RESOURCES;
  	$orderby  = 'resource_name';
    $blokType = 18; 
  } else {
    print "Under Construction ...";
    return (0);
  }

	# Creating hashes with the inactive items
	%hosts_inactive         = getInactiveItems($dbh, "select host_name from $TABLE_HOSTS where $serverAnd enabled=0");
  %hostgroups_inactive    = getInactiveItems($dbh, "select hostgroup_name from $TABLE_HOSTGROUPS where $serverAnd enabled=0");
  %contacts_inactive      = getInactiveItems($dbh, "select contact_name from $TABLE_CONTACTS where $serverAnd enabled=0");
  %contactgroups_inactive = getInactiveItems($dbh, "select contactgroup_name from $TABLE_CONTACTGROUPS where $serverAnd enabled=0");
  %commands_inactive      = getInactiveItems($dbh, "select command_name from $TABLE_COMMANDS where $serverAnd enabled=0");
  %misccommands_inactive  = getInactiveItems($dbh, "select command_name from $TABLE_MISCCOMMANDS where $serverAnd enabled=0");
  %servicegroups_inactive = getInactiveItems($dbh, "select servicegroup_name from $TABLE_SERVICEGROUPS where $serverAnd enabled=0");
  
  # Creating a backup if the file already exists  	
  if (-e $filename)
	{ 
		print "<p><font color=\"#FFFF00\">WARNING</font> -- File already exists, creating backup ==> $filename.bak!</p>\n";
		rename("$filename", "$filename.bak") || die "Can't rename file!";
	}
	
	$rvOpen = open(CFG, ">$filename");
	
	# Export to file
	if (! $rvOpen) {
    print "<p><font color=\"#FF0000\">FAILED</font> -- Export failed: Cannot create $filename!</p>\n";
    exit(0);
  }

	my $localtime = localtime();	
	print CFG "################################################################################################\n";
	print CFG "#                                                                                               \n";
	print CFG "# " . uc($table) . " - Generated with $APPLICATION_SHORTNAME v$APPLICATION_VERSION on $localtime\n";
	print CFG "#                                                                                               \n";
	print CFG "################################################################################################\n\n";
	
  $sql = "SELECT * FROM $table WHERE enabled=\"1\"";
  $sql = $sql . " $whereAnd " if (defined $whereAnd and $whereAnd ne '');
  $sql = $sql . " and server_name=\"$server_name\"" if (defined $server_name and $server_name ne ''); 
  $sql = $sql . " and category=\"$category\"" if (defined $category and $category ne '');
  $sql = $sql . " order by $orderby";
  $sth = $dbh->prepare( $sql ) or $rv = doErrorTrapDBI('$dbh->prepare()', $sql, $dbh->errstr, $debug) if $rv;
  $sth->execute() or $rv = doErrorTrapDBI('$sth->execute()', $sql, $dbh->errstr, $debug) if $rv;

  if ( $rv ) {
	  my $numFields = $sth->{'NUM_OF_FIELDS'};
	  
	  if ( $sth->rows ) {
	    while(my $hash_ref = $sth->fetchrow_hashref) {
	      print CFG "define $prefix {\n" if $blokType != 18;
	
	      if ($blokType == 1) {
	        doExport_Command ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 2) {
	        doExport_Contact ($dbh, *CFG, $hash_ref, $prefix, \%contactgroups_inactive, \%misccommands_inactive);
	      } elsif ($blokType == 3) {
	        doExport_Contactgroup ($dbh, *CFG, $hash_ref, $prefix, \%contacts_inactive);
	      } elsif ($blokType == 6) {
	        doExport_Host ($dbh, *CFG, $hash_ref, $prefix, \%hosts_inactive, \%hostgroups_inactive, \%contactgroups_inactive); 
	      } elsif ($blokType == 7) {
	        doExport_Hostdependency ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 8) {
	        doExport_Hostescalation ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 9) {
	        doExport_Hostextinfo ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 10) {
	        doExport_Hostgroup ($dbh, *CFG, $hash_ref, $prefix, \%contactgroups_inactive, \%hosts_inactive);
	      } elsif ($blokType == 11) {
	        doExport_Service ($dbh, *CFG, $hash_ref, $prefix, \%servicegroups_inactive, \%contactgroups_inactive);
	      } elsif ($blokType == 12) {
	        doExport_Servicedependency ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 13) {
	        doExport_Serviceescalation ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 14) {
	        doExport_Serviceextinfo ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 15) {
	        doExport_Servicegroup ($dbh, *CFG, $hash_ref, $prefix, \%services_inactive);
	      } elsif ($blokType == 16) {
	        doExport_Timeperiod ($dbh, *CFG, $hash_ref, $prefix);
	      } elsif ($blokType == 18) {
	        doExport_Resources ($dbh, *CFG, $hash_ref, $prefix);	      
        }	
	      print CFG "}\n\n" if $blokType != 18;
	    }
    }

    $sth->finish() or $rv = doErrorTrapDBI('$sth->finish', $sql, $dbh->errstr, $debug) if $rv;
  }

  close(CFG);
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doExport_Command {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;

  print $CFG "  command_name $hash_ref->{command_name}\n" if (defined $hash_ref->{command_name});
  print $CFG "  command_line $hash_ref->{line}\n" if (defined $hash_ref->{line});
}

# ---------------------------------------------------------------------------------
		
sub doExport_Contact {
  my ($dbh, $CFG, $hash_ref, $prefix, $contactgroups_inactive, $misccommands_inactive) = @_;

  print $CFG "  contact_name $hash_ref->{contact_name}\n" if (defined $hash_ref->{contact_name});
  print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
  print $CFG "  contactgroups " . getActiveItems($hash_ref->{contactgroups}, 1, $contactgroups_inactive) . "\n" if (defined $hash_ref->{contactgroups} and $hash_ref->{contactgroups} ne '' and $NAGIOS_VERSION =~ '2');
  print $CFG "  host_notification_period $hash_ref->{host_notification_period}\n" if (defined $hash_ref->{host_notification_period} and $hash_ref->{host_notification_period} ne '');
  print $CFG "  service_notification_period $hash_ref->{service_notification_period}\n" if (defined $hash_ref->{service_notification_period} and $hash_ref->{service_notification_period} ne '');
  print $CFG "  host_notification_options $hash_ref->{host_notification_options}\n" if (defined $hash_ref->{host_notification_options} and $hash_ref->{host_notification_options} ne '');
  print $CFG "  service_notification_options $hash_ref->{service_notification_options}\n" if (defined $hash_ref->{service_notification_options} and $hash_ref->{service_notification_options} ne '');
  print $CFG "  host_notification_commands " . getActiveItems($hash_ref->{host_notification_commands}, 1, $miscommands_inactive) . "\n" if (defined $hash_ref->{host_notification_commands} and $hash_ref->{host_notification_commands} ne '');
  print $CFG "  service_notification_commands " . getActiveItems($hash_ref->{service_notification_commands}, 1, $misscommands_inactive) . "\n" if (defined $hash_ref->{service_notification_commands} and $hash_ref->{service_notification_commands} ne '');
  print $CFG "  email $hash_ref->{email}\n" if (defined $hash_ref->{email} and $hash_ref->{email} ne '');
  print $CFG "  pager $hash_ref->{pager}\n" if (defined $hash_ref->{pager} and $hash_ref->{pager} ne '');
  print $CFG "  addresses $hash_ref->{addresses}\n" if (defined $hash_ref->{addresses} and $hash_ref->{addresses} ne '' and $NAGIOS_VERSION =~ '2');
}

# ---------------------------------------------------------------------------------
		
sub doExport_Contactgroup {
  my ($dbh, $CFG, $hash_ref, $prefix, $contacts_inactive) = @_;

  print $CFG "  contactgroup_name $hash_ref->{contactgroup_name}\n" if (defined $hash_ref->{contactgroup_name});
  print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
  print $CFG "  members " . getActiveItems($hash_ref->{members}, 1, $contacts_inactive) . "\n" if (defined $hash_ref->{members} and $hash_ref->{members} ne '');
}

# ---------------------------------------------------------------------------------
			
sub doExport_Host {
  my ($dbh, $CFG, $hash_ref, $prefix, $hosts_inactive, $hostgroups_inactive, $contactgroups_inactive) = @_;

  if (defined $hash_ref->{register}) {
    if ($hash_ref->{register} == 0) {
      print $CFG "  name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    } else {
      print $CFG "  use $hash_ref->{use}\n" if (defined $hash_ref->{use} and $hash_ref->{use} ne '');
      print $CFG "  host_name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    }

    print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
    print $CFG "  address $hash_ref->{address}\n" if (defined $hash_ref->{address} and $hash_ref->{address} ne '');
    print $CFG "  parents " . getActiveItems($hash_ref->{parents}, 1, $hosts_inactive) . "\n" if (defined $hash_ref->{parents} and $hash_ref->{parents} ne '');
    print $CFG "  hostgroups " . getActiveItems($hash_ref->{hostgroups}, 1, $hostgroups_inactive) . "\n" if (defined $hash_ref->{hostgroups} and $hash_ref->{hostgroups} ne '' and $NAGIOS_VERSION =~ '2');
    print $CFG "  check_command $hash_ref->{check_command}\n" if (defined $hash_ref->{check_command} and $hash_ref->{check_command} ne '');
    print $CFG "  max_check_attempts $hash_ref->{max_check_attempts}\n" if (defined $hash_ref->{max_check_attempts} and $hash_ref->{max_check_attempts} != 0);
		print $CFG "  checks_enabled $hash_ref->{checks_enabled}\n" if (defined $hash_ref->{checks_enabled} and $hash_ref->{checks_enabled} != 0 and $NAGIOS_VERSION =~ '1');
    print $CFG "  check_interval $hash_ref->{check_interval}\n" if (defined $hash_ref->{check_interval} and $hash_ref->{check_interval} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  active_checks_enabled $hash_ref->{active_checks_enabled}\n" if (defined $hash_ref->{active_checks_enabled} and $hash_ref->{active_checks_enabled} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  passive_checks_enabled $hash_ref->{passive_checks_enabled}\n" if (defined $hash_ref->{passive_checks_enabled} and $hash_ref->{passive_checks_enabled} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  check_period $hash_ref->{check_period}\n" if (defined $hash_ref->{check_period} and $hash_ref->{check_period} ne '' and $NAGIOS_VERSION =~ '2');
    print $CFG "  obsess_over_host $hash_ref->{obsess_over_host}\n" if (defined $hash_ref->{obsess_over_host} and $hash_ref->{obsess_over_host} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  check_freshness $hash_ref->{check_freshness}\n" if (defined $hash_ref->{check_freshness} and $hash_ref->{check_freshness} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  freshness_threshold $hash_ref->{freshness_threshold}\n" if (defined $hash_ref->{freshness_threshold} and $hash_ref->{freshness_threshold} != 0 and $NAGIOS_VERSION =~ '2');
    print $CFG "  event_handler $hash_ref->{event_handler}\n" if (defined $hash_ref->{event_handler} and $hash_ref->{event_handler} ne '');
    print $CFG "  event_handler_enabled $hash_ref->{event_handler_enabled}\n" if (defined $hash_ref->{event_handler_enabled} and $hash_ref->{event_handler_enabled} != 0);
    print $CFG "  low_flap_threshold $hash_ref->{low_flap_threshold}\n" if (defined $hash_ref->{low_flap_threshold} and $hash_ref->{low_flap_threshold} != 0);
    print $CFG "  high_flap_threshold $hash_ref->{high_flap_threshold}\n" if (defined $hash_ref->{high_flap_threshold} and $hash_ref->{high_flap_threshold} != 0);
    print $CFG "  flap_detection_enabled $hash_ref->{flap_detection_enabled}\n" if (defined $hash_ref->{flap_detection_enabled} and $hash_ref->{flap_detection_enabled} != 0);
    print $CFG "  process_perf_data $hash_ref->{process_perf_data}\n" if (defined $hash_ref->{process_perf_data} and $hash_ref->{process_perf_data} != 0);
    print $CFG "  retain_status_information $hash_ref->{retain_status_information}\n" if (defined $hash_ref->{retain_status_information} and $hash_ref->{retain_status_information} != 0);
    print $CFG "  retain_nonstatus_information $hash_ref->{retain_nonstatus_information}\n" if (defined $hash_ref->{retain_nonstatus_information} and $hash_ref->{retain_nonstatus_information} != 0);
    print $CFG "  contact_groups " . getActiveItems($hash_ref->{contact_groups}, 1, $contactgroups_inactive) . "\n" if (defined $hash_ref->{contact_groups} and $hash_ref->{contact_groups} ne '' and $NAGIOS_VERSION =~ '2');
    print $CFG "  notification_interval $hash_ref->{notification_interval}\n" if (defined $hash_ref->{notification_interval} and $hash_ref->{notification_interval} != 0);
    print $CFG "  notification_period $hash_ref->{notification_period}\n" if (defined $hash_ref->{notification_period} and $hash_ref->{notification_period} ne '');
    print $CFG "  notification_options $hash_ref->{notification_options}\n" if (defined $hash_ref->{notification_options} and $hash_ref->{notification_options} ne '');
    print $CFG "  notifications_enabled $hash_ref->{notifications_enabled}\n" if (defined $hash_ref->{notifications_enabled} and $hash_ref->{notifications_enabled} != 0);
    print $CFG "  stalking_options $hash_ref->{stalking_options}\n" if (defined $hash_ref->{stalking_options} and $hash_ref->{stalking_options} ne '');

    print $CFG "  register $hash_ref->{register}\n" if ($hash_ref->{register} == 0);
  }
}

# ---------------------------------------------------------------------------------
		
sub doExport_Hostdependency {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
}

# ---------------------------------------------------------------------------------
		
sub doExport_Hostescalation {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
}

# ---------------------------------------------------------------------------------
		
sub doExport_Hostextinfo {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;

	if (defined $hash_ref->{register}) {
    if ($hash_ref->{register} == 0) {
      print $CFG "  name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    } else {
      print $CFG "  use $hash_ref->{use}\n" if (defined $hash_ref->{use} and $hash_ref->{use} ne '');
      print $CFG "  host_name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    }

    print $CFG "  notes $hash_ref->{notes}\n" if (defined $hash_ref->{notes} and $hash_ref->{notes} ne '');
    print $CFG "  notes_url $hash_ref->{notes_url}\n" if (defined $hash_ref->{notes_url} and $hash_ref->{notes_url} ne '');
    print $CFG "  action_url $hash_ref->{action_url}\n" if (defined $hash_ref->{action_url} and $hash_ref->{action_url} ne '');
    print $CFG "  icon_image $hash_ref->{icon_image}\n" if (defined $hash_ref->{icon_image} and $hash_ref->{icon_image} ne '');
    print $CFG "  icon_image_alt $hash_ref->{icon_image_alt}\n" if (defined $hash_ref->{icon_image_alt} and $hash_ref->{icon_image_alt} ne '');
    print $CFG "  vrml_image $hash_ref->{vrml_image}\n" if (defined $hash_ref->{vrml_image} and $hash_ref->{vrml_image} ne '');
    print $CFG "  statusmap_image $hash_ref->{statusmap_image}\n" if (defined $hash_ref->{statusmap_image} and $hash_ref->{statusmap_image} ne '');
    print $CFG "  2d_coords $hash_ref->{'2d_coords'}\n" if (defined $hash_ref->{'2d_coords'} and $hash_ref->{'2d_coords'} ne '');
    print $CFG "  3d_coords $hash_ref->{'3d_coords'}\n" if (defined $hash_ref->{'3d_coords'} and $hash_ref->{'3d_coords'} ne '');

  }
 
}

# ---------------------------------------------------------------------------------
		
sub doExport_Hostgroup {
  my ($dbh, $CFG, $hash_ref, $prefix, $contactgroups_inactive, $hosts_inactive) = @_;

  print $CFG "  hostgroup_name $hash_ref->{hostgroup_name}\n" if (defined $hash_ref->{hostgroup_name});
  print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
  print $CFG "  contact_groups " . getActiveItems($hash_ref->{contact_groups}, 1, $contactgroups_inactive) . "\n" if (defined $hash_ref->{contact_groups} and $hash_ref->{contact_groups} ne '' and $NAGIOS_VERSION =~ '1');
  print $CFG "  members " . getActiveItems($hash_ref->{members}, 1, $hosts_inactive) . "\n" if (defined $hash_ref->{members} and $hash_ref->{members} ne '');
}

# ---------------------------------------------------------------------------------
		
sub doExport_Service {
  my ($dbh, $CFG, $hash_ref, $prefix, $servicegroups_inactive, $contactgroups_inactive) = @_;

  if (defined $hash_ref->{register}) {
    if ($hash_ref->{register} == 0) {
      print $CFG "  name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    } else {
      print $CFG "  use $hash_ref->{use}\n" if (defined $hash_ref->{use} and $hash_ref->{use} ne '');
      print $CFG "  host_name $hash_ref->{host_name}\n" if (defined $hash_ref->{host_name});
    }

    print $CFG "  service_description $hash_ref->{service_description}\n" if (defined $hash_ref->{service_description} and $hash_ref->{service_description} ne '');
    print $CFG "  servicegroups " . getActiveItems($hash_ref->{servicegroups}, 1, $servicegroups_inactive) . "\n" if (defined $hash_ref->{servicegroups} and $hash_ref->{servicegroups} ne '' and $NAGIOS_VERSION =~ '2');
    print $CFG "  is_volatile $hash_ref->{is_volatile}\n" if (defined $hash_ref->{is_volatile} and $hash_ref->{is_volatile} != 0);

    if (defined $hash_ref->{check_command} and $hash_ref->{check_command} ne '') {
      print $CFG "  check_command " .$hash_ref->{check_command};
      print $CFG "!" .$hash_ref->{check_command_parameters} if (defined $hash_ref->{check_command_parameters} and $hash_ref->{check_command_parameters} ne '');
      print $CFG "\n";
    }

    print $CFG "  max_check_attempts $hash_ref->{max_check_attempts}\n" if (defined $hash_ref->{max_check_attempts} and $hash_ref->{max_check_attempts} != 0);
    print $CFG "  normal_check_interval $hash_ref->{normal_check_interval}\n" if (defined $hash_ref->{normal_check_interval} and $hash_ref->{normal_check_interval} != 0);
    print $CFG "  retry_check_interval $hash_ref->{retry_check_interval}\n" if (defined $hash_ref->{retry_check_interval} and $hash_ref->{retry_check_interval} != 0);
    print $CFG "  active_checks_enabled $hash_ref->{active_checks_enabled}\n" if (defined $hash_ref->{active_checks_enabled} and $hash_ref->{active_checks_enabled} != 0);
    print $CFG "  passive_checks_enabled $hash_ref->{passive_checks_enabled}\n" if (defined $hash_ref->{passive_checks_enabled} and $hash_ref->{passive_checks_enabled} != 0);
    print $CFG "  check_period $hash_ref->{check_period}\n" if (defined $hash_ref->{check_period} and $hash_ref->{check_period} ne '');
    print $CFG "  parallelize_check $hash_ref->{parallelize_check}\n" if (defined $hash_ref->{parallelize_check} and $hash_ref->{parallelize_check} != 0);
    print $CFG "  obsess_over_service $hash_ref->{obsess_over_service}\n" if (defined $hash_ref->{obsess_over_service} and $hash_ref->{obsess_over_service} != 0);
    print $CFG "  check_freshness $hash_ref->{check_freshness}\n" if (defined $hash_ref->{check_freshness} and $hash_ref->{check_freshness} != 0);
    print $CFG "  freshness_threshold $hash_ref->{freshness_threshold}\n" if (defined $hash_ref->{freshness_threshold} and $hash_ref->{freshness_threshold} != 0);
    print $CFG "  event_handler $hash_ref->{event_handler}\n" if (defined $hash_ref->{event_handler} and $hash_ref->{event_handler} ne '');
    print $CFG "  event_handler_enabled $hash_ref->{event_handler_enabled}\n" if (defined $hash_ref->{event_handler_enabled} and $hash_ref->{event_handler_enabled} != 0);
    print $CFG "  low_flap_threshold $hash_ref->{low_flap_threshold}\n" if (defined $hash_ref->{low_flap_threshold} and $hash_ref->{low_flap_threshold} != 0);
    print $CFG "  high_flap_threshold $hash_ref->{high_flap_threshold}\n" if (defined $hash_ref->{high_flap_threshold} and $hash_ref->{high_flap_threshold} != 0);
    print $CFG "  flap_detection_enabled $hash_ref->{flap_detection_enabled}\n" if (defined $hash_ref->{flap_detection_enabled} and $hash_ref->{flap_detection_enabled} != 0);
    print $CFG "  process_perf_data $hash_ref->{process_perf_data}\n" if (defined $hash_ref->{process_perf_data} and $hash_ref->{process_perf_data} != 0);
    print $CFG "  retain_status_information $hash_ref->{retain_status_information}\n" if (defined $hash_ref->{retain_status_information} and $hash_ref->{retain_status_information} != 0);
    print $CFG "  retain_nonstatus_information $hash_ref->{retain_nonstatus_information}\n" if (defined $hash_ref->{retain_nonstatus_information} and $hash_ref->{retain_nonstatus_information} != 0);
    print $CFG "  notification_interval $hash_ref->{notification_interval}\n" if (defined $hash_ref->{notification_interval} and $hash_ref->{notification_interval} != 0);
    print $CFG "  notification_period $hash_ref->{notification_period}\n" if (defined $hash_ref->{notification_period} and $hash_ref->{notification_period} ne '');
    print $CFG "  notification_options $hash_ref->{notification_options}\n" if (defined $hash_ref->{notification_options} and $hash_ref->{notification_options} ne '');
    print $CFG "  notifications_enabled $hash_ref->{notifications_enabled}\n" if (defined $hash_ref->{notifications_enabled} and $hash_ref->{notifications_enabled} != 0);
    print $CFG "  contact_groups " . getActiveItems($hash_ref->{contact_groups}, 1, $contactgroups_inactive) . "\n" if (defined $hash_ref->{contact_groups} and $hash_ref->{contact_groups} ne '');
    print $CFG "  stalking_options $hash_ref->{stalking_options}\n" if (defined $hash_ref->{stalking_options} and $hash_ref->{stalking_options} ne '');

    print $CFG "  register $hash_ref->{register}\n" if ($hash_ref->{register} == 0);
  }
}

# ---------------------------------------------------------------------------------
		
sub doExport_Servicedependency {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
}

# ---------------------------------------------------------------------------------
		
sub doExport_Serviceescalation {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
}

# ---------------------------------------------------------------------------------
		
sub doExport_Serviceextinfo {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
}

# ---------------------------------------------------------------------------------
		
sub doExport_Servicegroup {
  my ($dbh, $CFG, $hash_ref, $prefix, $services_inactive) = @_;

  print $CFG "  servicegroup_name $hash_ref->{servicegroup_name}\n" if (defined $hash_ref->{servicegroup_name});
  print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
  print $CFG "  members " . getActiveItems($hash_ref->{members}, 1, $services_inactive) . "\n" if (defined $hash_ref->{members} and $hash_ref->{members} ne '');
}

# ---------------------------------------------------------------------------------
		
sub doExport_Timeperiod {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;
  
  print $CFG "  timeperiod_name $hash_ref->{timeperiod_name}\n" if (defined $hash_ref->{timeperiod_name});
  print $CFG "  alias $hash_ref->{alias}\n" if (defined $hash_ref->{alias} and $hash_ref->{alias} ne '');
  print $CFG "  sunday $hash_ref->{sunday}\n" if (defined $hash_ref->{sunday} and $hash_ref->{sunday} ne '');
  print $CFG "  monday $hash_ref->{monday}\n" if (defined $hash_ref->{monday} and $hash_ref->{monday} ne '');
  print $CFG "  tuesday $hash_ref->{tuesday}\n" if (defined $hash_ref->{tuesday} and $hash_ref->{tuesday} ne '');
  print $CFG "  wednesday $hash_ref->{wednesday}\n" if (defined $hash_ref->{wednesday} and $hash_ref->{wednesday} ne '');
  print $CFG "  thursday $hash_ref->{thursday}\n" if (defined $hash_ref->{thursday} and $hash_ref->{thursday} ne '');
  print $CFG "  friday $hash_ref->{friday}\n" if (defined $hash_ref->{friday} and $hash_ref->{friday} ne '');
  print $CFG "  saturday $hash_ref->{saturday}\n" if (defined $hash_ref->{saturday} and $hash_ref->{saturday} ne '');
}

# ---------------------------------------------------------------------------------

sub doExport_Resources {
  my ($dbh, $CFG, $hash_ref, $prefix) = @_;

	for (my $teller=1; $teller <= 32; $teller++) {
    my $label = "USER$teller";
    print $CFG "\$$label\$=" .$hash_ref->{ $label }. "\n"  if $hash_ref->{ $label };
  }
}

# ---------------------------------------------------------------------------------

sub Export_Database {
	print "<p class=\"export\">Dumping database ...</p>\n";
	if (-e "$MYSQLDUMP_DUMPFILE.sql")
	{ 
		print "<p><font color=\"#FFFF00\">WARNING</font> -- File already exists, creating backup ==> $MYSQLDUMP_DUMPFILE.bak!</p>\n";
		rename("$MYSQLDUMP_DUMPFILE.sql","$MYSQLDUMP_DUMPFILE.bak") || die "Can't rename file!";
	}
	my $command = "$MYSQLDUMP_PROG --compress --host=$DB_SERVER --user=$DB_USERNAME --password=$DB_PASSWORD $DB_CATALOG > $MYSQLDUMP_DUMPFILE.sql";
	system($command);
	print "<p><font color=\"#00FF00\">OK</font> -- Export completed ==> $MYSQLDUMP_DUMPFILE.sql!</p>\n";
}

# ---------------------------------------------------------------------------------

1;