# ---------------------------------------------------------------------------------
# NCPL_IMPORT.pm
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ---------------------------------------------------------------------------------
 
sub DisplayImportForm
{
	my ($prgscriptname, $action, $type, $submit, $dbh, $CGISESSID, $debug) = @_;

	my $filename = ($type == 0 ) ? "$PATH_IMPORT" : "$PATH_IMPORT/$FILENAMES{$type}";
	my $label    = ($type == 0 ) ? "directory:"   : "filename:";
	
	print "<p>Please enter the required data for the import:</p>\n";
	print "<form method=\"POST\" action=\"$prgscriptname\">\n";
	print "  <input type=\"hidden\"  name=\"action\"     size=\"50\" value=\"$action\">\n";
	print "  <input type=\"hidden\"  name=\"type\"       size=\"50\" value=\"$type\">\n";
	print "  <input type=\"hidden\"  name=\"CGISESSID\"  size=\"50\" value=\"$CGISESSID\">\n";
	print "  <input type=\"hidden\"  name=\"submitForm\" size=\"50\" value=\"1\">\n";
	print "  <input type=\"hidden\"  name=\"debug\"      size=\"50\" value=\"$debug\">\n";
	print "<table>\n";
	html_dbcombobox("server_name", "server_name:", "required", $server_name, $dbh, $SQL_SERVERS, '', '', '', 0, $action, $debug);
  html_textbox("category", "category:", "general", 50, $category, '', '', '', 0, $action, $debug);	
  html_textbox("filename", $label, "required", 50, $filename, '', '', '', 0, $action, $debug);
	print "</table>\n";
	print "<p><input type=\"submit\" name=\"import\" value=\"Import\"> <input type=\"reset\" name=\"reset\" value=\"Reset\"></p>\n";
	print "</form>\n";
}

# ---------------------------------------------------------------------------------

sub initImport {
	my($prgscriptname, $filename, $type, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug) = @_;
	
	if($submit==1) 
	{
		print "<p>Importing ...</p>\n";
		print "<p><IMG SRC=\"../images/running.gif\" HSPACE=\"0\" VSPACE=\"0\" BORDER=\"0\" NAME=\"Progress\" title=\"Please Wait ...\" alt=\"Please Wait ...\"></p>\n";
    my $rv = 1;
		if ( $dbh and $rv ) {
			if ($type == 0) {
		    my @filenames;
		    my $rvOpendir = opendir(DIR, $filename);
			
		    if ($rvOpendir) {
		      @filenames = readdir(DIR);
		      closedir(DIR);
		    } 

				if(@filenames > 2) {
			    foreach my $tFilename (@filenames) {
			      $rv = import_nagios_cfg_file ($rv, $dbh, "$filename/$tFilename", $type, $server_name, $category, $debug) if ($tFilename =~ /.cfg$/);
			      ($rv == 1 ? print "<p><font color=\"#00FF00\">OK</font> -- Import of $tFilename completed!</p>\n" : print "<p><font color=\"#FF0000\">FAILED</font> -- Import of $tFilename failed!</p>\n") if ($tFilename =~ /.cfg$/);
			    }
			  }
			  else {
			  	print "<p>No files available in $filename!</p>\n";
			  }
		  } 
		  else {
		      $rv = import_nagios_cfg_file ($rv, $dbh, $filename, $type, $server_name, $category, $debug);
		      ($rv == 1 ? print "<p><font color=\"#00FF00\">OK</font> -- Import of $filename completed!</p>\n" : print "<p><font color=\"#FF0000\">FAILED</font> -- Import of $filename failed!</p>\n") if ($filename =~ /.cfg$/);		      
		  }
		}
	}
	else 
	{
		DisplayImportForm($prgscriptname, $filename, $type, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug);
	}
}

# ---------------------------------------------------------------------------------

sub import_nagios_cfg_file {
  my ($rv, $dbh, $filename, $type, $server_name, $category, $debug) = @_;

  my (@lines, %configHash, $startBlok, $startBlokType, $endBlok, $blok, $error);
  $startBlok = $startBlokType = $endBlok = $error = 0;
  %configHash = ();

  if (-e "$filename") {
    my $rvOpen = open(READ, "$filename");

    if ($rvOpen) {
      while (<READ>) {
        s/\r*//g;
        s/\n*//g;
        s/^\s*//g;
        s/\s*$//g; 
        s/\s*,\s*/,/g;
        push (@lines, $_) if ($_ ne '' and $_ !~ /^#/);
      }

	  close(READ);
    } else {
      print "<p>Can't open '$filename' file!</p>\n";
      return 0;
    }
  } else {
    print "<p>The file '$filename' doesn't exist!</p>\n";
    return 0;
  }

  foreach my $line (@lines) {
    if (! $startBlok) {
      if ($line =~ /^\s*define\s+command\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 1;
      } elsif ($line =~ /^\s*define\s+contact\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 2;
      } elsif ($line =~ /^\s*define\s+contactgroup\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 3;
      } elsif ($line =~ /^\s*define\s+host\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 6;
      } elsif ($line =~ /^\s*define\s+hostdependency\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 7;
      } elsif ($line =~ /^\s*define\s+hostescalation\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 8;
      } elsif ($line =~ /^\s*define\s+hostextinfo\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 9;
      } elsif ($line =~ /^\s*define\s+hostgroup\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 10;
      } elsif ($line =~ /^\s*define\s+service\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 11;
      } elsif ($line =~ /^\s*define\s+servicedependency\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 12;
      } elsif ($line =~ /^\s*define\s+serviceescalation\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 13;
      } elsif ($line =~ /^\s*define\s+serviceextinfo\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 14;
      } elsif ($line =~ /^\s*define\s+servicegroup\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 15;
      } elsif ($line =~ /^\s*define\s+timeperiod\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 16;
      } elsif ($line =~ /^\s*\$USER\d+\$\s*=\s*/) {
        $startBlok = 2; $startBlokType = 18;

        if ($line =~ /^\s*\$USER\d+\$\s*=/) {
          my ($label, $value) = split (/\s*=\s*/, $line, 2);
          $label =~ s/\$//g;
          $configHash { $label } = $value;
        }  
      } elsif ($line =~ /^\s*define\s+hostextinfo\s*{\s*$/i) {
        $startBlok = 1; $startBlokType = 19;
      }
    } elsif ($startBlok == 2) {
      if ($line =~ /^\s*\$USER\d+\$\s*=/) {
        my ($label, $value) = split (/\s*=\s*/, $line, 2);
        $label =~ s/\$//g;

        if (defined $configHash { $label }) {
          $error = 1;
          print "<p>Duplicate line: $label=$value!</p>\n";
        } else {
          $configHash { $label } = $value;
        }
      }
    } elsif (! $endBlok) {
      if ($line =~ /^\s*}\s*$/i) {
        $endBlok = 1;
      } else {
        $line =~ s/^\s*//g;
        $line =~ s/\s*$//g;
        my ($label, $value) = split (/\s/, $line, 2);
        $label =~ s/\s*$//g;

        if (defined $value) {
          $value =~ s/^\s*//g;
          ($value, undef) = split (/;/, $value, 2);
          $value =~ s/\s*$//g;
        } else {
          #$value = '<NIHIL>';
          $value = '';
        }

        if (defined $configHash { $label }) {
          $error = 1;
          print "<p>Duplicate line: $label $value!</p>\n";
        } else {
          $configHash { $label } = $value;
        }
      }
    }

    if ($startBlok and $endBlok) {
      if (! $error) {
        if (($type == 0 or $type == 1 or $type == 17) and $startBlokType == 1) {
          $rv = doImport_Command ($rv, $dbh, \%configHash, $type, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 2) and $startBlokType == 2) {
          $rv = doImport_Contact ($rv, $dbh, \%configHash, ($type == 0) ? $startBlokType : $type, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 3) and $startBlokType == 3) {
          $rv = doImport_Contactgroup ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 6) and $startBlokType == 6) {
          $rv = doImport_Host ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 7) and $startBlokType == 7) {
          $rv = doImport_Hostdependency ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 8) and $startBlokType == 8) {
          $rv = doImport_Hostescalation ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 9) and $startBlokType == 9) {
          $rv = doImport_Hostextinfo ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 10) and $startBlokType == 10) {
          $rv = doImport_Hostgroup ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 11) and $startBlokType == 11) {
          $rv = doImport_Service ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 12) and $startBlokType == 12) {
          $rv = doImport_Servicedependency ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 13) and $startBlokType == 13) {
          $rv = doImport_Serviceescalation ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 14) and $startBlokType == 14) {
          $rv = doImport_Serviceextinfo ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 15) and $startBlokType == 15) {
          $rv = doImport_Servicegroup ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } elsif (($type == 0 or $type == 16) and $startBlokType == 16) {
          $rv = doImport_Timeperiod ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
        } else {
          print "<p>Required type $type and detected type $startBlokType don't match!</p>\n";
          $rv = 0;
        }
      }

      $startBlok = $startBlokType = $endBlok = $error = 0;
      %configHash = ();
      $blok = '';
    } elsif (!$startBlok and $endBlok) {
      print "<p>--- !! IMPORT ERROR !! ---<p>\n";
    }

    last if (!$rv);
  }

  if ($startBlok == 2) {
    if (($type == 0 or $type == 18) and $startBlokType == 18) {
      $rv = doImport_Resources ($rv, $dbh, \%configHash, $startBlokType, $server_name, $category, $debug);
    } else {
      print "<p>Required type $type and detected type $startBlokType don't match!</p>\n";
      $rv = 0;
    }
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Command {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;
 
 	if ($debug) {
    print "define command {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $command_name = (defined $configHash->{ 'command_name' }) ? $configHash->{ 'command_name' } : '';
  my $line         = (defined $configHash->{ 'command_line' }) ? $configHash->{ 'command_line' } : '';
  
  my $table  = ($type == 17) ? $TABLE_MISCCOMMANDS : $TABLE_COMMANDS;
  
  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", command_name="' .$command_name. '", line=' .$dbh->quote($line). ', `desc`="", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $table, "command_name = '$command_name'", $sqlSet, $debug);
  
  print "$command_name<br>\n" if ($command_name);
  
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Contact {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define contact {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $contact_name                  = (defined $configHash->{ 'contact_name' })                  ? $configHash->{ 'contact_name' }                  : '';
  my $alias                         = (defined $configHash->{ 'alias' })                         ? $configHash->{ 'alias' }                         : '';
  my $contactgroups                 = (defined $configHash->{ 'contactgroups' })                 ? $configHash->{ 'contactgroups' }                 : '';
  my $host_notification_period      = (defined $configHash->{ 'host_notification_period' })      ? $configHash->{ 'host_notification_period' }      : '';
  my $service_notification_period   = (defined $configHash->{ 'service_notification_period' })   ? $configHash->{ 'service_notification_period' }   : '';
  my $host_notification_options     = (defined $configHash->{ 'host_notification_options' })     ? $configHash->{ 'host_notification_options' }     : '';
  my $service_notification_options  = (defined $configHash->{ 'service_notification_options' })  ? $configHash->{ 'service_notification_options' }  : '';
  my $host_notification_commands    = (defined $configHash->{ 'host_notification_commands' })    ? $configHash->{ 'host_notification_commands' }    : '';
  my $service_notification_commands = (defined $configHash->{ 'service_notification_commands' }) ? $configHash->{ 'service_notification_commands' } : '';
  my $email                         = (defined $configHash->{ 'email' })                         ? $configHash->{ 'email' }                         : '';
  my $pager                         = (defined $configHash->{ 'pager' })                         ? $configHash->{ 'pager' }                         : '';
  my $addresses                     = (defined $configHash->{ 'addresses' })                     ? $configHash->{ 'addresses' }                     : '';

  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", contact_name="' .$contact_name. '", alias=' .$dbh->quote($alias). ', contactgroups="' .$contactgroups. '", host_notification_period="' .$host_notification_period. '", service_notification_period="' .$service_notification_period. '", host_notification_options="' .$host_notification_options. '", service_notification_options="' .$service_notification_options. '", host_notification_commands="' .$host_notification_commands. '", service_notification_commands="' .$service_notification_commands. '", email="' .$email. '", pager="' .$pager. '", addresses="' .$addresses. '", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_CONTACTS, "contact_name = '$contact_name'", $sqlSet, $debug);
  
  print "$contact_name -- $alias<br>\n" if ($contact_name and $alias);
  
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Contactgroup {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define contactgroup {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $contactgroup_name = (defined $configHash->{ 'contactgroup_name' }) ? $configHash->{ 'contactgroup_name' } : '';
  my $alias             = (defined $configHash->{ 'alias' })             ? $configHash->{ 'alias' }             : '';
  my $members           = (defined $configHash->{ 'members' })           ? $configHash->{ 'members' }           : '';

  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", contactgroup_name="' .$contactgroup_name. '", alias=' .$dbh->quote($alias). ', members="' .$members. '", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_CONTACTGROUPS, "contactgroup_name = '$contactgroup_name'", $sqlSet, $debug);
  
  print "$contactgroup_name -- $alias<br>\n" if ($contactgroup_name and $alias);
  
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Host {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define host {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $name                         = $configHash->{ 'name' }        if (defined $configHash->{ 'name' });
  my $host_name                    = $configHash->{ 'host_name' }   if (defined $configHash->{ 'host_name' });

  my $alias                        = (defined $configHash->{ 'alias' })                        ? $configHash->{ 'alias' }                        : '';
  my $use                          = (defined $configHash->{ 'use' })                          ? $configHash->{ 'use' }                          : '';
  my $address                      = (defined $configHash->{ 'address' })                      ? $configHash->{ 'address' }                      : '';
  my $parents                      = (defined $configHash->{ 'parents' })                      ? $configHash->{ 'parents' }                      : '';
  my $hostgroups                   = (defined $configHash->{ 'hostgroups' })                   ? $configHash->{ 'hostgroups' }                   : '';
  my $check_command                = (defined $configHash->{ 'check_command' })                ? $configHash->{ 'check_command' }                : '';
  my $max_check_attempts           = (defined $configHash->{ 'max_check_attempts' })           ? $configHash->{ 'max_check_attempts' }           : '0';
  my $checks_enabled               = (defined $configHash->{ 'checks_enabled' })               ? $configHash->{ 'checks_enabled' }               : '0';
  my $check_interval               = (defined $configHash->{ 'check_interval' })               ? $configHash->{ 'check_interval' }               : '0';
  my $active_checks_enabled        = (defined $configHash->{ 'active_checks_enabled' })        ? $configHash->{ 'active_checks_enabled' }        : '0';
  my $passive_checks_enabled       = (defined $configHash->{ 'passive_checks_enabled' })       ? $configHash->{ 'passive_checks_enabled' }       : '0';
  my $check_period                 = (defined $configHash->{ 'check_period' })                 ? $configHash->{ 'check_period' }                 : '';
  my $obsess_over_host             = (defined $configHash->{ 'obsess_over_host' })             ? $configHash->{ 'obsess_over_host' }             : '0';
  my $check_freshness              = (defined $configHash->{ 'check_freshness' })              ? $configHash->{ 'check_freshness' }              : '0';
  my $freshness_threshold          = (defined $configHash->{ 'freshness_threshold' })          ? $configHash->{ 'freshness_threshold' }          : '0';
  my $event_handler                = (defined $configHash->{ 'event_handler' })                ? $configHash->{ 'event_handler' }                : '';
  my $event_handler_enabled        = (defined $configHash->{ 'event_handler_enabled' })        ? $configHash->{ 'event_handler_enabled' }        : '0';
  my $low_flap_threshold           = (defined $configHash->{ 'low_flap_threshold' })           ? $configHash->{ 'low_flap_threshold' }           : '0';
  my $high_flap_threshold          = (defined $configHash->{ 'high_flap_threshold' })          ? $configHash->{ 'high_flap_threshold' }          : '0';
  my $flap_detection_enabled       = (defined $configHash->{ 'flap_detection_enabled' })       ? $configHash->{ 'flap_detection_enabled' }       : '0';
  my $process_perf_data            = (defined $configHash->{ 'process_perf_data' })            ? $configHash->{ 'process_perf_data' }            : '0';
  my $retain_status_information    = (defined $configHash->{ 'retain_status_information' })    ? $configHash->{ 'retain_status_information' }    : '0';
  my $retain_nonstatus_information = (defined $configHash->{ 'retain_nonstatus_information' }) ? $configHash->{ 'retain_nonstatus_information' } : '0';
  my $contact_groups               = (defined $configHash->{ 'contact_groups' })               ? $configHash->{ 'contact_groups' }               : '';
  my $notification_interval        = (defined $configHash->{ 'notification_interval' })        ? $configHash->{ 'notification_interval' }        : '0';
  my $notification_period          = (defined $configHash->{ 'notification_period' })          ? $configHash->{ 'notification_period' }          : '';
  my $notification_options         = (defined $configHash->{ 'notification_options' })         ? $configHash->{ 'notification_options' }         : '';
  my $notifications_enabled        = (defined $configHash->{ 'notifications_enabled' })        ? $configHash->{ 'notifications_enabled' }        : '0';
  my $stalking_options             = (defined $configHash->{ 'stalking_options' })             ? $configHash->{ 'stalking_options' }             : '';
  my $register                     = (defined $configHash->{ 'register' })                     ? $configHash->{ 'register' }                     : '1';

  my $nameOrHostname               = (defined $host_name) ? $host_name : ((defined $name) ? $name : '');
  my @nameOrHostname               = split (/\s*,\s*/, $nameOrHostname);

  foreach my $nameOrHostname (@nameOrHostname) {
    print "$nameOrHostname<br>\n" if ($nameOrHostname);
    my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", host_name="' .$nameOrHostname. '", alias=' .$dbh->quote($alias). ', address="' .$address. '", `use`="' .$use. '", parents="' .$parents. '", hostgroups="' .$hostgroups. '", check_command="' .$check_command. '", max_check_attempts="' .$max_check_attempts. '", checks_enabled="' .$checks_enabled. '", check_interval="' .$check_interval. '", active_checks_enabled="' .$active_checks_enabled. '", passive_checks_enabled="' .$passive_checks_enabled. '", check_period="' .$check_period. '", obsess_over_host="' .$obsess_over_host. '", check_freshness="' .$check_freshness. '", freshness_threshold="' .$freshness_threshold. '", event_handler="' .$event_handler. '", event_handler_enabled="' .$event_handler_enabled. '", low_flap_threshold="' .$low_flap_threshold. '", high_flap_threshold="' .$high_flap_threshold. '", flap_detection_enabled="' .$flap_detection_enabled. '", process_perf_data="' .$process_perf_data. '", retain_status_information="' .$retain_status_information. '", retain_nonstatus_information="' .$retain_nonstatus_information. '", contact_groups="' .$contact_groups. '", notification_interval="' .$notification_interval. '", notification_period="' .$notification_period. '", notification_options="' .$notification_options. '", notifications_enabled="' .$notifications_enabled. '", stalking_options="' .$stalking_options. '", register="' .$register. '", enabled="1"';
  	$rv = import_record_to_dbi ($rv, $dbh, $TABLE_HOSTS, "host_name = '$nameOrHostname'", $sqlSet, $debug);
  }

	return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Hostdependency {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define hostdependency {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Hostescalation {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define hostescalation {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Hostextinfo {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define hostextinfo {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $name                         = $configHash->{ 'name' }        if (defined $configHash->{ 'name' });
  my $host_name                    = $configHash->{ 'host_name' }   if (defined $configHash->{ 'host_name' });

  my $use                          = (defined $configHash->{ 'use' })                          ? $configHash->{ 'use' }                          : '';
  my $notes                        = (defined $configHash->{ 'notes' })                        ? $configHash->{ 'notes' }                        : '';
  my $notes_url                    = (defined $configHash->{ 'notes_url' })                    ? $configHash->{ 'notes_url' }                    : '';
  my $action_url                   = (defined $configHash->{ 'action_url' })                   ? $configHash->{ 'action_url' }                   : '';
  my $icon_image                   = (defined $configHash->{ 'icon_image' })                   ? $configHash->{ 'icon_image' }                   : '';
  my $icon_image_alt               = (defined $configHash->{ 'icon_image_alt' })               ? $configHash->{ 'icon_image_alt' }               : '';
  my $vrml_image                   = (defined $configHash->{ 'vrml_image' })                   ? $configHash->{ 'vrml_image' }                   : '';
  my $statusmap_image              = (defined $configHash->{ 'statusmap_image' })              ? $configHash->{ 'statusmap_image' }              : '';
  my $coords_2d                    = (defined $configHash->{ '2d_coords' })                    ? $configHash->{ '2d_coords' }                    : '';
  my $coords_3d                    = (defined $configHash->{ '3d_coords' })                    ? $configHash->{ '3d_coords' }                    : '';
  
  my $nameOrHostname               = (defined $host_name)                                      ? $host_name : ((defined $name) ? $name : '');
  my @nameOrHostname               = split (/\s*,\s*/, $nameOrHostname);

	my $register                     = (defined $name)                                           ? 0                                               : 1;
		
  foreach my $nameOrHostname (@nameOrHostname) {
  	print "$nameOrHostname<br>\n" if ($nameOrHostname);	
    my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", host_name="' .$nameOrHostname. '", `use`="' .$use. '", notes="' .$notes. '", notes_url="' .$notes_url. '", action_url="' .$action_url. '", icon_image="' .$icon_image. '", icon_image_alt="' .$icon_image_alt. '", vrml_image="' .$vrml_image. '", statusmap_image="' .$statusmap_image. '", 2d_coords="' .$coords_2d. '", 3d_coords="' .$coords_3d. '", register="' .$register. '", enabled="1"';
    $rv = import_record_to_dbi ($rv, $dbh, $TABLE_HOSTEXTINFO, "host_name = '$nameOrHostname'", $sqlSet, $debug);
  }

	return ($rv);
  
}

# ---------------------------------------------------------------------------------

sub doImport_Hostgroup {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define hostgroup {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $hostgroup_name = (defined $configHash->{ 'hostgroup_name' }) ? $configHash->{ 'hostgroup_name' } : '';
  my $alias          = (defined $configHash->{ 'alias' })          ? $configHash->{ 'alias' }          : '';
  my $contact_groups = (defined $configHash->{ 'contact_groups' }) ? $configHash->{ 'contact_groups' } : '';
  my $members        = (defined $configHash->{ 'members' })        ? $configHash->{ 'members' }        : '';

  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", hostgroup_name="' .$hostgroup_name. '", alias=' .$dbh->quote($alias). ', contact_groups="' .$contact_groups. '", members="' .$members. '", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_HOSTGROUPS, "hostgroup_name = '$hostgroup_name'", $sqlSet, $debug);

	print "$hostgroup_name -- $alias<br>\n" if ($hostgroup_name and $alias);
	
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Service {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define service {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $name                         = $configHash->{ 'name' }        if (defined $configHash->{ 'name' });
  my $host_name                    = $configHash->{ 'host_name' }   if (defined $configHash->{ 'host_name' });

  my $use                          = (defined $configHash->{ 'use' })                          ? $configHash->{ 'use' }                          : '';
  my $service_description          = (defined $configHash->{ 'service_description' })          ? $configHash->{ 'service_description' }          : '';
  my $servicegroups                = (defined $configHash->{ 'servicegroups' })                ? $configHash->{ 'servicegroups' }                : '';
  my $is_volatile                  = (defined $configHash->{ 'is_volatile' })                  ? $configHash->{ 'is_volatile' }                  : '0';
  
  my ($check_command, $check_command_parameters) = split (/!/, $configHash->{ 'check_command' }, 2) if (defined $configHash->{ 'check_command' });
  $check_command                   = '' if (! defined $check_command);
  $check_command_parameters        = '' if (! defined $check_command_parameters);
  
  my $max_check_attempts           = (defined $configHash->{ 'max_check_attempts' })           ? $configHash->{ 'max_check_attempts' }           : '0';
  my $normal_check_interval        = (defined $configHash->{ 'normal_check_interval' })        ? $configHash->{ 'normal_check_interval' }        : '0';
  my $retry_check_interval         = (defined $configHash->{ 'retry_check_interval' })         ? $configHash->{ 'retry_check_interval' }         : '0';
  my $active_checks_enabled        = (defined $configHash->{ 'active_checks_enabled' })        ? $configHash->{ 'active_checks_enabled' }        : '0';
  my $passive_checks_enabled       = (defined $configHash->{ 'passive_checks_enabled' })       ? $configHash->{ 'passive_checks_enabled' }       : '0';
  my $check_period                 = (defined $configHash->{ 'check_period' })                 ? $configHash->{ 'check_period' }                 : '';
  my $parallelize_check            = (defined $configHash->{ 'parallelize_check' })            ? $configHash->{ 'parallelize_check' }            : '0';
  my $obsess_over_service          = (defined $configHash->{ 'obsess_over_service' })          ? $configHash->{ 'obsess_over_service' }          : '0';
  my $check_freshness              = (defined $configHash->{ 'check_freshness' })              ? $configHash->{ 'check_freshness' }              : '0';
  my $freshness_threshold          = (defined $configHash->{ 'freshness_threshold' })          ? $configHash->{ 'freshness_threshold' }          : '0';
  my $event_handler                = (defined $configHash->{ 'event_handler' })                ? $configHash->{ 'event_handler' }                : '';
  my $event_handler_enabled        = (defined $configHash->{ 'event_handler_enabled' })        ? $configHash->{ 'event_handler_enabled' }        : '0';
  my $low_flap_threshold           = (defined $configHash->{ 'low_flap_threshold' })           ? $configHash->{ 'low_flap_threshold' }           : '0';
  my $high_flap_threshold          = (defined $configHash->{ 'high_flap_threshold' })          ? $configHash->{ 'high_flap_threshold' }          : '0';
  my $flap_detection_enabled       = (defined $configHash->{ 'flap_detection_enabled' })       ? $configHash->{ 'flap_detection_enabled' }       : '0';
  my $process_perf_data            = (defined $configHash->{ 'process_perf_data' })            ? $configHash->{ 'process_perf_data' }            : '0';
  my $retain_status_information    = (defined $configHash->{ 'retain_status_information' })    ? $configHash->{ 'retain_status_information' }    : '0';
  my $retain_nonstatus_information = (defined $configHash->{ 'retain_nonstatus_information' }) ? $configHash->{ 'retain_nonstatus_information' } : '0';
  my $notification_interval        = (defined $configHash->{ 'notification_interval' })        ? $configHash->{ 'notification_interval' }        : '0';
  my $notification_period          = (defined $configHash->{ 'notification_period' })          ? $configHash->{ 'notification_period' }          : '';
  my $notification_options         = (defined $configHash->{ 'notification_options' })         ? $configHash->{ 'notification_options' }         : '';
  my $notifications_enabled        = (defined $configHash->{ 'notifications_enabled' })        ? $configHash->{ 'notifications_enabled' }        : '0';
  my $contact_groups               = (defined $configHash->{ 'contact_groups' })               ? $configHash->{ 'contact_groups' }               : '';
  my $stalking_options             = (defined $configHash->{ 'stalking_options' })             ? $configHash->{ 'stalking_options' }             : '';
  my $register                     = (defined $configHash->{ 'register' })                     ? $configHash->{ 'register' }                     : '1';

  my $nameOrHostname               = (defined $host_name) ? $host_name : ((defined $name) ? $name : '');
  my @nameOrHostname               = split (/\s*,\s*/, $nameOrHostname);

  foreach my $nameOrHostname (@nameOrHostname) {
  	print "$nameOrHostname -- $service_description<br>\n" if ($nameOrHostname and $service_description);
    my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", host_name="' .$nameOrHostname. '", service_description=' .$dbh->quote($service_description). ', `use`="' .$use. '", servicegroups="' .$servicegroups. '", is_volatile="' .$is_volatile. '", check_command=' .$dbh->quote($check_command). ', check_command_parameters=' .$dbh->quote($check_command_parameters). ', max_check_attempts="' .$max_check_attempts. '", normal_check_interval="' .$normal_check_interval. '", retry_check_interval="' .$retry_check_interval. '", active_checks_enabled="' .$active_checks_enabled. '", passive_checks_enabled="' .$passive_checks_enabled. '", check_period="' .$check_period. '", parallelize_check="' .$parallelize_check. '", obsess_over_service="' .$obsess_over_service. '", check_freshness="' .$check_freshness. '", freshness_threshold="' .$freshness_threshold. '", event_handler="' .$event_handler. '", event_handler_enabled="' .$event_handler_enabled. '", low_flap_threshold="' .$low_flap_threshold. '", high_flap_threshold="' .$high_flap_threshold. '", flap_detection_enabled="' .$flap_detection_enabled. '", process_perf_data="' .$process_perf_data. '", retain_status_information="' .$retain_status_information. '", retain_nonstatus_information="' .$retain_nonstatus_information. '", notification_interval="' .$notification_interval. '", notification_period="' .$notification_period. '", notification_options="' .$notification_options. '", notifications_enabled="' .$notifications_enabled. '", contact_groups="' .$contact_groups. '", stalking_options="' .$stalking_options. '", register="' .$register. '", enabled="1"';
    $rv = import_record_to_dbi ($rv, $dbh, $TABLE_SERVICES, 'host_name = "' .$nameOrHostname. '" and service_description = ' .$dbh->quote($service_description), $sqlSet, $debug);
  }
  
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Servicedependency {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define servicedependency {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Serviceescalation {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define serviceescalation {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Serviceextinfo {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define serviceextinfo {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Servicegroup {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define servicegroup {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $servicegroup_name = (defined $configHash->{ 'servicegroup_name' }) ? $configHash->{ 'servicegroup_name' } : '';
  my $alias             = (defined $configHash->{ 'alias' })             ? $configHash->{ 'alias' }             : '';
  my $members           = (defined $configHash->{ 'members' })           ? $configHash->{ 'members' }           : '';

  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", servicegroup_name="' .$servicegroup_name. '", alias=' .$dbh->quote($alias). ', members="' .$members. '", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_SERVICEGROUPS, "servicegroup_name = '$servicegroup_name'", $sqlSet, $debug);
  
  print "$servicegroup_name<br>\n" if ($servicegroup_name);
  
  return ($rv);
}


# ---------------------------------------------------------------------------------

sub doImport_Timeperiod {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  if ($debug) {
    print "define timeperiod {\n";

    foreach my $label ( sort keys ( %$configHash ) ) {
      print "  $label " .$configHash->{ $label }. "\n";
    }

    print "}\n\n";
  }

  my $timeperiod_name = (defined $configHash->{ 'timeperiod_name' }) ? $configHash->{ 'timeperiod_name' } : '';
  my $alias           = (defined $configHash->{ 'alias' })           ? $configHash->{ 'alias' }           : '';
  my $sunday          = (defined $configHash->{ 'sunday' })          ? $configHash->{ 'sunday' }          : '';
  my $monday          = (defined $configHash->{ 'monday' })          ? $configHash->{ 'monday' }          : '';
  my $tuesday         = (defined $configHash->{ 'tuesday' })         ? $configHash->{ 'tuesday' }         : '';
  my $wednesday       = (defined $configHash->{ 'wednesday' })       ? $configHash->{ 'wednesday' }       : '';
  my $thursday        = (defined $configHash->{ 'thursday' })        ? $configHash->{ 'thursday' }        : '';
  my $friday          = (defined $configHash->{ 'friday' })          ? $configHash->{ 'friday' }          : '';
  my $saturday        = (defined $configHash->{ 'saturday' })        ? $configHash->{ 'saturday' }        : '';

  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", timeperiod_name="' .$timeperiod_name. '", alias=' .$dbh->quote($alias). ', sunday="' .$sunday. '", monday="' .$monday. '", tuesday="' .$tuesday. '", wednesday="' .$wednesday. '", thursday="' .$thursday. '", friday="' .$friday. '", saturday="' .$saturday. '", enabled="1"';
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_TIMEPERIODS, "timeperiod_name = '$timeperiod_name'", $sqlSet, $debug);
  
  print "$timeperiod_name<br>\n" if ($timeperiod_name);
  
  return ($rv);
}

# ---------------------------------------------------------------------------------

sub doImport_Resources {
  my ($rv, $dbh, $configHash, $type, $server_name, $category, $debug) = @_;

  # my $resource_name = (defined $configHash->{ 'resource_name' }) ? $configHash->{ 'resource_name' } : '';
  my $resource_name = 'default';
  
  my $sqlSet = 'server_name="' .$server_name. '", category="' .$category. '", resource_name="' .$resource_name. '", enabled="1"';

  foreach my $label ( sort keys ( %$configHash ) ) {
    print "\$$label\$=" .$configHash->{ $label }. "<br>\n"; #if ($debug);
    $sqlSet .= ", " .$label. "=\"" .$configHash->{ $label }. "\"";
  }
  $rv = import_record_to_dbi ($rv, $dbh, $TABLE_RESOURCES, "resource_name = '$resource_name'", $sqlSet, $debug);
  return ($rv);
  
}

# ---------------------------------------------------------------------------------

sub import_record_to_dbi {
  my ($rv, $dbh, $table, $sqlWhere, $sqlSet, $debug) = @_;

  return ($rv) if ($debug == 9); # for testing without writing records to the database

  if ($rv) {
    my ($sql, $sth, $numberRecordsIntoQuery);

    $sql = "SELECT count(*) FROM $table WHERE $sqlWhere";
    $sth = $dbh->prepare( $sql ) or $rv = doErrorTrapDBI('$dbh->prepare()', $sql, $dbh->errstr, $debug) if $rv;
    $sth->execute() or $rv = doErrorTrapDBI('$sth->execute()', $sql, $dbh->errstr, $debug) if $rv;
    $numberRecordsIntoQuery = ($rv) ? $sth->fetchrow_array() : 0;
    $sth->finish() or $rv = doErrorTrapDBI('$sth->finish()', $sql, $dbh->errstr, $debug) if $rv;

    $sql = ($numberRecordsIntoQuery) ? "UPDATE $table SET $sqlSet WHERE $sqlWhere" : "INSERT INTO $table SET $sqlSet" if $rv;
    $sth = $dbh->prepare( $sql ) or $rv = doErrorTrapDBI('$dbh->prepare()', $sql, $dbh->errstr, $debug) if $rv;
    $sth->execute() or $rv = doErrorTrapDBI('$sth->execute()', $sql, $dbh->errstr, $debug) if $rv;
    $sth->finish() or $rv = doErrorTrapDBI('$sth->finish()', $sql, $dbh->errstr, $debug) if $rv;
  }

  return ($rv);
}

# ---------------------------------------------------------------------------------

1;