# ---------------------------------------------------------------------------------
# NCPL_SESSIONS.pm
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ---------------------------------------------------------------------------------

sub UserAccessControl {

my ($prgscriptname, $cgi, $pagetitle, $html_js, $html_css, $action, $submit, $dbh, $debug) = @_;
my $CGISESSID = $cgi->param('CGISESSID') || undef;
my $session   = new CGI::Session("driver:File", $CGISESSID, {Directory=>'../sessions'});
my $trials    = $session->param("~login-trials") || 0;
$CGISESSID    = $session->id();

if($action eq 'logon' && $submit==1) 
{ 
	#if($session->is_expired()) 
	#{
	#	DisplayLogonForm($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, "Your session expired. Please refresh!", $CGISESSID, $debug);
	#}
	#elsif ( $trials >= 3 ) 
	if( $trials >= 3 )
	{
	  DisplayLogonForm($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, "You failed 3 times in a row. Your session is blocked!", $CGISESSID, $debug);
	}
	else 
	{		
		$session->param("~login-trials", ++$trials);
		my $user_username  = $cgi->param('user_username') || '';
		my $user_password  = $cgi->param('user_password') || '';
		my $sql = "select * from $TABLE_USERS where user_username=\"$user_username\" and user_password=\"$user_password\" and enabled=1";
		my ($sth, $rows) = doQueryDBI($dbh, $sql, '', '', 0);
		if($sth->rows()) 
		{	
			while(my $ref = $sth->fetchrow_hashref()) 
			{
				$session->param("~username", $ref->{"user_username"});
				$session->param("~alias", $ref->{"user_alias"});
				$session->param("~email", $ref->{"user_email"});
				$session->param("~userlevel", $ref->{"user_userlevel"});
				$session->param("~login-trials", 0);
				$session->param("~user_logged_in", 1);
				$session->expire("~user_logged_in", $SESSIONS_EXPIRE);
			}
		}
		else 
		{
			DisplayLogonForm($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, "Invalid username or password!", $CGISESSID, $debug);
		}
		my $rc = $sth->finish() or doErrorTrapDBI('$sth->finish()', $sql, $dbh->errstr, $debug);
	}
}
elsif($action eq 'logoff' && $submit==1)
{
  $session->clear(["~login-trials"]);
	$session->clear(["~user_logged_in"]);
	DisplayLogonForm($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, "You are now logged off!", $CGISESSID, $debug);	
}
else 
{
	DisplayLogonForm($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, undef, $CGISESSID, $debug) if (! defined $session->param("~user_logged_in") or $session->param("~user_logged_in") == 0);
}

return ($session,$CGISESSID);

}

# ---------------------------------------------------------------------------------

sub DisplayLogonForm
{
my ($prgscriptname, $pagetitle, $html_js, $html_css, $action, $submit, $message, $CGISESSID, $debug) = @_;

html_start($pagetitle, $html_js, $html_css, undef, $debug);
	
print <<END
<p class="logontitle">$pagetitle</p>
END
;

print "<p class=\"logonmessage\"><b>$message</b></p>\n" if $message;

print <<END
<p align="center"><b>Please enter your username and password:</b></p>
<form method="POST" name="logonForm" action="$prgscriptname" onsubmit="return validateLogonForm();">
<input type="hidden" name="action"     size="50" value="logon">
<input type="hidden" name="CGISESSID"  size="50" value="$CGISESSID">
<input type="hidden" name="submitForm" size="50" value="1">
<input type="hidden" name="debug"      size="50" value="$debug">
<table align="center" border="0">
  <tr>
    <td><b>Username:</b></td>
    <td><input type="text" name="user_username" size="25"></td>
  </tr>
  <tr>
    <td><b>Password: </b></td>
    <td><input type="password" name="user_password" size="25"></td>
  </tr>
</table>
<p align="center"><input type="submit" value="Log On" name="submitForm"> <input type="reset" value="Reset" name="resetForm"></p>
</form>
END
;
html_debug($debug);
html_stop(0, 0, undef, $debug);		
}

# ---------------------------------------------------------------------------------

1;