# ---------------------------------------------------------------------------------
# NCPL_MAIL.pm
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ---------------------------------------------------------------------------------

sub sendEmail {
  
  my($from, $to, $cc, $bcc, $subject, $message, $html, $debug) = @_;
  
  use Mail::Sendmail;

  my %mail = (
      'From'     => $from,
      'To'       => $to,
      'Cc'       => $cc,
      'Bcc'      => $bcc,
      'Subject'  => $subject,
      'Message'  => $message,
      'X-Mailer' => "Mail::Sendmail version $Mail::Sendmail::VERSION",
      'X-custom' => "$APPLICATION_SHORTNAME v$APPLICATION_VERSION",
      'Date'     => Mail::Sendmail::time_to_date( time() ),
      'Smtp'     => $SMTP_SERVER,
      'Port'     => $SMTP_PORT,
      'Mime'     => $SMTP_MIME,
      'Retries'  => $SMTP_RETRIES,
      'Delay'    => $SMTP_DELAY,
      'Debug'    => $debug,
  );

	$mail{'content-type'} = 'text/html; charset="iso-8859-1"' if $html;
	
	my $rc = sendmail %mail;
	
	if($debug) {
		if ($rc) { print "Mail sent OK.\n" }
		else     { print "Error sending mail: $Mail::Sendmail::error \n" }
		print "\n\$Mail::Sendmail::log says:\n", $Mail::Sendmail::log;
	}

	return $rc;
		
}

# ---------------------------------------------------------------------------------

sub sendTextEmail {
  
  my($from, $to, $cc, $bcc, $subject, $message, $debug) = @_;
  
  use Mail::Sendmail;

  my %mail = (
      'From'     => $from,
      'To'       => $to,
      'Cc'       => $cc,
      'Bcc'      => $bcc,
      'Subject'  => $subject,
      'Message'  => $message,
      'X-Mailer' => "Mail::Sendmail version $Mail::Sendmail::VERSION",
      'X-custom' => "$APPLICATION_SHORTNAME v$APPLICATION_VERSION",
      'Date'     => Mail::Sendmail::time_to_date( time() ),
      'Smtp'     => $SMTP_SERVER,
      'Port'     => $SMTP_PORT,
      'Mime'     => $SMTP_MIME,
      'Retries'  => $SMTP_RETRIES,
      'Delay'    => $SMTP_DELAY,
      'Debug'    => $debug,
  );

	my $rc = sendmail %mail;
	
	if($debug) {
		if ($rc) { print "Mail sent OK.\n" }
		else     { print "Error sending mail: $Mail::Sendmail::error \n" }
		print "\n\$Mail::Sendmail::log says:\n", $Mail::Sendmail::log;
	}

	return $rc;
		
}
      
# ---------------------------------------------------------------------------------
      
1;