# ---------------------------------------------------------------------------------
# NCPL_SQL.pm
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# --------------------------------------------------------------------------------- 

our $SQL_CHECKCOMMANDS         = "select command_name, command_name from $TABLE_COMMANDS where enabled=1 order by command_name";
our $SQL_CONTACTS						   = "select contact_name, alias from $TABLE_CONTACTS where enabled=1 order by contact_name";
our $SQL_CONTACTGROUPS         = "select contactgroup_name, alias from $TABLE_CONTACTGROUPS where enabled=1 order by contactgroup_name";
our $SQL_HOSTS                 = "select host_name, host_name from $TABLE_HOSTS where enabled=1 and register=1 order by host_name";
our $SQL_HOSTGROUPS            = "select hostgroup_name, alias from $TABLE_HOSTGROUPS where enabled=1 order by hostgroup_name";
our $SQL_MISCCOMMANDS          = "select command_name, command_name from $TABLE_MISCCOMMANDS where enabled=1 order by command_name";
our $SQL_SERVICEGROUPS         = "select servicegroup_name, alias from $TABLE_SERVICEGROUPS where enabled=1 order by servicegroup_name";
our $SQL_SERVICEGROUPMEMBERS   = "select concat(host_name , ',' , service_description) as `member_value`, concat(host_name , ' -- ' , service_description) as `member_text` from $TABLE_SERVICES where enabled=1 order by member_text";
our $SQL_TEMPLATES_HOSTS       = "select host_name, host_name from $TABLE_HOSTS where enabled=1 and register=0 order by host_name";
our $SQL_TEMPLATES_HOSTEXTINFO = "select host_name, host_name from $TABLE_HOSTEXTINFO where enabled=1 and register=0 order by host_name";
our $SQL_TEMPLATES_SERVICES    = "select host_name, host_name from $TABLE_SERVICES where enabled=1 and register=0 order by host_name";
our $SQL_TIMEPERIODS           = "select timeperiod_name, alias from $TABLE_TIMEPERIODS where enabled=1 order by timeperiod_name";
our $SQL_USERLEVELS            = "select userlevel_id, userlevel_alias from $TABLE_USERLEVELS where enabled=1 order by userlevel_id";
our $SQL_SERVERS               = "select server_name, server_name from $TABLE_SERVERS where enabled=1 order by server_name";
our $SQL_FILETYPES						 = "select filetype_id, filetype_alias from $TABLE_FILETYPES where enabled=1 order by filetype_alias";
our $SQL_ENVIRONMENTS          = "select environment_name, environment_alias from $TABLE_ENVIRONMENTS where enabled=1 order by environment_alias";

1;