#!/usr/bin/perl -w
# ---------------------------------------------------------------------------------
#  
# NCPL is the legal property of its developers, whose names are too numerous
# to list here.  Please refer to the AUTHORS file distributed with this
# source distribution.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# ---------------------------------------------------------------------------------

use strict;
use warnings;
use NCPL v1.000.043;
use NCPL qw(:DEFAULT :HTML :DB :SECURITY :EXPORT);

use CGI;
use CGI::Session qw/-ip-match/;
use DBI;

# ---------------------------------------------------------------------------------

my $prgname       = "NCPL :: Export";
my $prgtext       = "Export Nagios Config";
my $prgscriptname = $ENV{"SCRIPT_NAME"};
my $version 	    = "1.000.004";
my $description   = "This module makes it possible to export the nagios configuration.";

# ---------------------------------------------------------------------------------

my @html_js       = ('../js/logon.js' , '../js/export.js' , '../js/md5.js');
my @html_css      = ('../stylesheets/ncpl.css');

# ---------------------------------------------------------------------------------

my $cgi         = new CGI;
my $action      = (defined $cgi->param('action'))      ?  $cgi->param('action')      : 'doExportAll';
my $filetype    = (defined $cgi->param('filetype'))    ?  $cgi->param('filetype')    : 'ALL';
my $filename    = (defined $cgi->param('filename'))    ?  $cgi->param('filename')    : '';
my $server_name = (defined $cgi->param('server_name')) ?  $cgi->param('server_name') : '';
my $category    = (defined $cgi->param('category'))    ?  $cgi->param('category')    : '';
my $exportpath  = (defined $cgi->param('exportpath'))  ?  $cgi->param('exportpath')  : '';
my $submit      = (defined $cgi->param('submitForm'))  ?  $cgi->param('submitForm')  : 0;
my $debug       = (defined $cgi->param('debug'))       ?  $cgi->param('debug')       : 0;

my $body			  = ($submit) ? "ONLOAD=\"if (document.images) document.Progress.src='../images/spacer.gif';\"" : undef;

# ---------------------------------------------------------------------------------

my $dbh = DBI->connect("dbi:mysql:$DB_CATALOG:$DB_SERVER:$DB_PORT", "$DB_USERNAME", "$DB_PASSWORD" ) or die("Cannot connect to the database");	

my ($session, $CGISESSID) = UserAccessControl($prgscriptname, $cgi, $APPLICATION_NAME, \@html_js, \@html_css, $action, $submit, $dbh, $debug);

if (defined $session->param("~user_logged_in") && $session->param("~user_logged_in") == 1)
{
	html_start($prgname, \@html_js, \@html_css, $body, $debug);
	html_pagetitle($prgtext, $CGISESSID, $debug);
		
	if($submit) {
  	if($action    eq 'doExportAll')                 { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportCommands')            { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportContacts')            { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportContactgroups')       { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportHosts')               { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportHostdependencies')    { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportHostescalations')     { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportHostextinfo')         { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportHostgroups')          { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportResources')           { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportServices')            { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportServicedependencies') { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportServiceescalations')  { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportServiceextinfo')      { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportServicegroups')       { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportTimeperiods')         { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  elsif($action eq 'doExportMisccommands')        { initExport($prgscriptname, $filetype, $exportpath, $filename, $server_name, $category, $action, $submit, $dbh, $CGISESSID, $debug); }
	  else { DisplayExportForm($prgscriptname, $server_name, $category, $filetype, $filename, $action, $submit, $dbh, $CGISESSID, $debug); }
	} else {
			DisplayExportForm($prgscriptname, $server_name, $category, $filetype, $filename, $action, $submit, $dbh, $CGISESSID, $debug);
  }
  
	html_description($description, $debug);
	html_debug($debug);
	html_stop(1, 1, "right", $debug);
}

$dbh->disconnect();

exit(0);

# ---------------------------------------------------------------------------------