/*
SQLyog - Free MySQL GUI v5.0
Host - 4.1.15-log : Database - ncpl
*********************************************************************
Server version : 4.1.15-log
*/


create database if not exists `ncpl`;

USE `ncpl`;

/*Table structure for table `nagios_commands` */

DROP TABLE IF EXISTS `nagios_commands`;

CREATE TABLE `nagios_commands` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `command_name` varchar(64) NOT NULL default '',
  `line` text NOT NULL,
  `desc` text,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`command_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `command_name` (`command_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_commands` */

/*Table structure for table `nagios_contactgroups` */

DROP TABLE IF EXISTS `nagios_contactgroups`;

CREATE TABLE `nagios_contactgroups` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `contactgroup_name` varchar(64) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `members` text NOT NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`contactgroup_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `alias` (`alias`),
  KEY `contactgroup_name` (`contactgroup_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_contactgroups` */

/*Table structure for table `nagios_contacts` */

DROP TABLE IF EXISTS `nagios_contacts`;

CREATE TABLE `nagios_contacts` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `contact_name` varchar(64) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `contactgroups` text COMMENT 'Only used by Nagios 2.x',
  `host_notification_period` varchar(64) NOT NULL default '',
  `service_notification_period` varchar(64) NOT NULL default '',
  `host_notification_options` text NOT NULL,
  `service_notification_options` text NOT NULL,
  `host_notification_commands` text,
  `service_notification_commands` text,
  `email` varchar(255) default NULL,
  `pager` varchar(255) default NULL,
  `addresses` text COMMENT 'Only used by Nagios 2.x',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`contact_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `alias` (`alias`),
  KEY `contact_name` (`contact_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_contacts` */

/*Table structure for table `nagios_hostdependencies` */

DROP TABLE IF EXISTS `nagios_hostdependencies`;

CREATE TABLE `nagios_hostdependencies` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `dependent_host_name` varchar(64) NOT NULL default '',
  `inherits_parent` tinyint(1) unsigned default NULL COMMENT 'Only used by Nagios 2.x',
  `execution_failure_criteria` text COMMENT 'Only used by Nagios 2.x',
  `notification_failure_criteria` text NOT NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`,`dependent_host_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `host_name` (`host_name`),
  KEY `dependent_host_name` (`dependent_host_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_hostdependencies` */

/*Table structure for table `nagios_hostescalations` */

DROP TABLE IF EXISTS `nagios_hostescalations`;

CREATE TABLE `nagios_hostescalations` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `hostgroup_name` varchar(64) default NULL COMMENT 'Only used by Nagios 2.x',
  `contact_groups` text NOT NULL,
  `first_notification` int(11) NOT NULL default '0',
  `last_notification` int(11) NOT NULL default '0',
  `notification_interval` int(11) NOT NULL default '0',
  `escalation_period` varchar(64) default NULL COMMENT 'Only used by Nagios 2.x',
  `escalation_options` text COMMENT 'Only used by Nagios 2.x',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `hostgroup_name` (`hostgroup_name`),
  KEY `host_name` (`host_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_hostescalations` */

/*Table structure for table `nagios_hostextinfo` */

DROP TABLE IF EXISTS `nagios_hostextinfo`;

CREATE TABLE `nagios_hostextinfo` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `use` varchar(64) default NULL,
  `notes` varchar(255) default NULL,
  `notes_url` varchar(255) default NULL,
  `action_url` varchar(255) default NULL,
  `icon_image` varchar(255) default NULL,
  `icon_image_alt` varchar(255) default NULL,
  `vrml_image` varchar(255) default NULL,
  `statusmap_image` varchar(255) default NULL,
  `2d_coords` varchar(255) default NULL,
  `3d_coords` varchar(255) default NULL,
  `register` tinyint(1) unsigned NOT NULL default '0',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `use` (`use`),
  KEY `host_name` (`host_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_hostextinfo` */

/*Table structure for table `nagios_hostgroupescalations` */

DROP TABLE IF EXISTS `nagios_hostgroupescalations`;

CREATE TABLE `nagios_hostgroupescalations` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `hostgroup_name` varchar(64) NOT NULL default '' COMMENT 'Only used by Nagios 1.x',
  `contact_groups` text NOT NULL COMMENT 'Only used by Nagios 1.x',
  `first_notification` int(11) unsigned NOT NULL default '0' COMMENT 'Only used by Nagios 1.x',
  `last_notification` int(11) unsigned NOT NULL default '0' COMMENT 'Only used by Nagios 1.x',
  `notification_interval` int(11) unsigned NOT NULL default '0' COMMENT 'Only used by Nagios 1.x',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`hostgroup_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `hostgroup_name` (`hostgroup_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Only used by Nagios 1.x; InnoDB free: 35840 kB';

/*Data for the table `nagios_hostgroupescalations` */

/*Table structure for table `nagios_hostgroups` */

DROP TABLE IF EXISTS `nagios_hostgroups`;

CREATE TABLE `nagios_hostgroups` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `hostgroup_name` varchar(64) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `contact_groups` text NOT NULL COMMENT 'Only used by Nagios 1.x',
  `members` text NOT NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`hostgroup_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `alias` (`alias`),
  KEY `hostgroup_name` (`hostgroup_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_hostgroups` */

/*Table structure for table `nagios_hosts` */

DROP TABLE IF EXISTS `nagios_hosts`;

CREATE TABLE `nagios_hosts` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `environments` text,
  `host_name` varchar(64) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `use` varchar(64) default NULL,
  `address` varchar(64) NOT NULL default '',
  `parents` text,
  `hostgroups` text COMMENT 'Only used by Nagios 2.x',
  `check_command` varchar(64) default NULL,
  `max_check_attempts` int(11) unsigned NOT NULL default '0',
  `checks_enabled` tinyint(1) unsigned default '0' COMMENT 'Only used by Nagios 1.x',
  `check_interval` int(11) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `active_checks_enabled` tinyint(1) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `passive_checks_enabled` tinyint(1) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `check_period` varchar(64) NOT NULL default '' COMMENT 'Only used by Nagios 2.x',
  `obsess_over_host` tinyint(1) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `check_freshness` tinyint(1) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `freshness_threshold` int(11) unsigned default '0' COMMENT 'Only used by Nagios 2.x',
  `event_handler` varchar(64) default NULL,
  `event_handler_enabled` tinyint(1) unsigned default '0',
  `low_flap_threshold` int(11) unsigned default '0',
  `high_flap_threshold` int(11) unsigned default '0',
  `flap_detection_enabled` tinyint(1) unsigned default '0',
  `process_perf_data` tinyint(1) unsigned NOT NULL default '0',
  `retain_status_information` tinyint(1) unsigned default '0',
  `retain_nonstatus_information` tinyint(1) unsigned default '0',
  `contact_groups` text NOT NULL COMMENT 'Only used by Nagios 2.x',
  `notification_interval` int(11) unsigned NOT NULL default '0',
  `notification_period` varchar(64) NOT NULL default '',
  `notification_options` text NOT NULL,
  `notifications_enabled` tinyint(1) unsigned default '0',
  `stalking_options` text NOT NULL,
  `register` tinyint(1) unsigned NOT NULL default '0',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `alias` (`alias`),
  KEY `host_name` (`host_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_hosts` */

/*Table structure for table `nagios_misccommands` */

DROP TABLE IF EXISTS `nagios_misccommands`;

CREATE TABLE `nagios_misccommands` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `command_name` varchar(64) NOT NULL default '',
  `line` text NOT NULL,
  `desc` text,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`command_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `command_name` (`command_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_misccommands` */

/*Table structure for table `nagios_resources` */

DROP TABLE IF EXISTS `nagios_resources`;

CREATE TABLE `nagios_resources` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `resource_name` varchar(64) NOT NULL default '',
  `USER1` varchar(255) default NULL,
  `USER2` varchar(255) default NULL,
  `USER3` varchar(255) default NULL,
  `USER4` varchar(255) default NULL,
  `USER5` varchar(255) default NULL,
  `USER6` varchar(255) default NULL,
  `USER7` varchar(255) default NULL,
  `USER8` varchar(255) default NULL,
  `USER9` varchar(255) default NULL,
  `USER10` varchar(255) default NULL,
  `USER11` varchar(255) default NULL,
  `USER12` varchar(255) default NULL,
  `USER13` varchar(255) default NULL,
  `USER14` varchar(255) default NULL,
  `USER15` varchar(255) default NULL,
  `USER16` varchar(255) default NULL,
  `USER17` varchar(255) default NULL,
  `USER18` varchar(255) default NULL,
  `USER19` varchar(255) default NULL,
  `USER20` varchar(255) default NULL,
  `USER21` varchar(255) default NULL,
  `USER22` varchar(255) default NULL,
  `USER23` varchar(255) default NULL,
  `USER24` varchar(255) default NULL,
  `USER25` varchar(255) default NULL,
  `USER26` varchar(255) default NULL,
  `USER27` varchar(255) default NULL,
  `USER28` varchar(255) default NULL,
  `USER29` varchar(255) default NULL,
  `USER30` varchar(255) default NULL,
  `USER31` varchar(255) default NULL,
  `USER32` varchar(255) default NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`resource_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `resource_name` (`resource_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_resources` */

insert into `nagios_resources` values 

('default',NULL,'default',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1);

/*Table structure for table `nagios_servicedependencies` */

DROP TABLE IF EXISTS `nagios_servicedependencies`;

CREATE TABLE `nagios_servicedependencies` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `service_description` varchar(255) NOT NULL default '',
  `dependent_host_name` varchar(64) NOT NULL default '',
  `dependent_service_description` varchar(255) NOT NULL default '',
  `inherits_parent` tinyint(1) unsigned default NULL COMMENT 'Only used by Nagios 2.x',
  `execution_failure_criteria` text,
  `notification_faillure_criteria` text,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`,`service_description`,`dependent_host_name`,`dependent_service_description`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `host_name` (`host_name`),
  KEY `service_description` (`service_description`),
  KEY `dependent_host_name` (`dependent_host_name`),
  KEY `dependent_service_description` (`dependent_service_description`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_servicedependencies` */

/*Table structure for table `nagios_serviceescalations` */

DROP TABLE IF EXISTS `nagios_serviceescalations`;

CREATE TABLE `nagios_serviceescalations` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `service_description` varchar(255) NOT NULL default '',
  `contact_groups` text NOT NULL,
  `first_notification` int(11) unsigned NOT NULL default '0',
  `last_notification` int(11) unsigned NOT NULL default '0',
  `notification_interval` int(11) unsigned NOT NULL default '0',
  `escalation_period` varchar(255) default NULL COMMENT 'Only used by Nagios 2.x',
  `escalation_options` text COMMENT 'Only used by Nagios 2.x',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`,`service_description`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `host_name` (`host_name`),
  KEY `service_description` (`service_description`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_serviceescalations` */

/*Table structure for table `nagios_serviceextinfo` */

DROP TABLE IF EXISTS `nagios_serviceextinfo`;

CREATE TABLE `nagios_serviceextinfo` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `service_description` varchar(255) NOT NULL default '',
  `notes` varchar(255) default NULL,
  `notes_url` varchar(255) default NULL,
  `action_url` varchar(255) default NULL,
  `icon_image` varchar(255) default NULL,
  `icon_image_alt` varchar(255) default NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`,`service_description`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `host_name` (`host_name`),
  KEY `service_description` (`service_description`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_serviceextinfo` */

/*Table structure for table `nagios_servicegroups` */

DROP TABLE IF EXISTS `nagios_servicegroups`;

CREATE TABLE `nagios_servicegroups` (
  `server_name` varchar(64) NOT NULL default '' COMMENT 'Only used by Nagios 2.x',
  `category` varchar(64) default NULL COMMENT 'Only used by Nagios 2.x',
  `servicegroup_name` varchar(64) NOT NULL default '' COMMENT 'Only used by Nagios 2.x',
  `alias` varchar(255) NOT NULL default '' COMMENT 'Only used by Nagios 2.x',
  `members` text NOT NULL COMMENT 'Only used by Nagios 2.x',
  `enabled` tinyint(1) unsigned NOT NULL default '0' COMMENT 'Only used by Nagios 2.x',
  PRIMARY KEY  (`server_name`,`servicegroup_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `alias` (`alias`),
  KEY `servicegroup_name` (`servicegroup_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Only used by Nagios 2.x';

/*Data for the table `nagios_servicegroups` */

/*Table structure for table `nagios_services` */

DROP TABLE IF EXISTS `nagios_services`;

CREATE TABLE `nagios_services` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `host_name` varchar(64) NOT NULL default '',
  `service_description` varchar(255) NOT NULL default '',
  `use` varchar(64) default NULL,
  `servicegroups` text COMMENT 'Only used by Nagios 2.x',
  `is_volatile` tinyint(1) unsigned default '0',
  `check_command` varchar(64) NOT NULL default '',
  `check_command_parameters` varchar(255) default NULL,
  `max_check_attempts` int(11) unsigned NOT NULL default '0',
  `normal_check_interval` int(11) unsigned NOT NULL default '0',
  `retry_check_interval` int(11) unsigned NOT NULL default '0',
  `active_checks_enabled` tinyint(1) unsigned default NULL,
  `passive_checks_enabled` tinyint(1) unsigned default NULL,
  `check_period` varchar(64) NOT NULL default '',
  `parallelize_check` tinyint(1) unsigned default '0',
  `obsess_over_service` tinyint(1) unsigned default NULL,
  `check_freshness` tinyint(1) unsigned default NULL,
  `freshness_threshold` int(11) unsigned default NULL,
  `event_handler` varchar(64) default NULL,
  `event_handler_enabled` tinyint(1) unsigned default NULL,
  `low_flap_threshold` int(11) unsigned default NULL,
  `high_flap_threshold` int(11) unsigned default NULL,
  `flap_detection_enabled` tinyint(1) unsigned default NULL,
  `process_perf_data` tinyint(1) unsigned default NULL,
  `retain_status_information` tinyint(1) unsigned default NULL,
  `retain_nonstatus_information` tinyint(1) unsigned default NULL,
  `notification_interval` int(11) unsigned NOT NULL default '0',
  `notification_period` varchar(64) NOT NULL default '',
  `notification_options` text NOT NULL,
  `notifications_enabled` tinyint(1) unsigned default NULL,
  `contact_groups` text NOT NULL,
  `stalking_options` text,
  `register` tinyint(1) unsigned NOT NULL default '0',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`host_name`,`service_description`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `host_name` (`host_name`),
  KEY `service_description` (`service_description`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_services` */

/*Table structure for table `nagios_timeperiods` */

DROP TABLE IF EXISTS `nagios_timeperiods`;

CREATE TABLE `nagios_timeperiods` (
  `server_name` varchar(64) NOT NULL default '',
  `category` varchar(64) default NULL,
  `timeperiod_name` varchar(64) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `sunday` varchar(255) default NULL,
  `monday` varchar(255) default NULL,
  `tuesday` varchar(255) default NULL,
  `wednesday` varchar(255) default NULL,
  `thursday` varchar(255) default NULL,
  `friday` varchar(255) default NULL,
  `saturday` varchar(255) default NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`,`timeperiod_name`),
  KEY `server_name` (`server_name`),
  KEY `category` (`category`),
  KEY `timeperiod_name` (`timeperiod_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `nagios_timeperiods` */

/*Table structure for table `ncpl_categories` */

DROP TABLE IF EXISTS `ncpl_categories`;

CREATE TABLE `ncpl_categories` (
  `category_filetype` int(11) unsigned NOT NULL default '0',
  `category_name` varchar(64) NOT NULL default '',
  `category_alias` varchar(255) default NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`category_filetype`,`category_name`),
  KEY `category_filetype` (`category_filetype`),
  KEY `category_name` (`category_name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_categories` */

/*Table structure for table `ncpl_environments` */

DROP TABLE IF EXISTS `ncpl_environments`;

CREATE TABLE `ncpl_environments` (
  `environment_name` varchar(64) NOT NULL default '',
  `environment_alias` varchar(255) default NULL,
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`environment_name`),
  KEY `environment_alias` (`environment_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_environments` */

insert into `ncpl_environments` values 

('ACC','Acceptation',1),

('DEV','Development',1),

('LOCAL','Local',1),

('PROD','Production',1),

('SIM','Simulatie',1),

('TEST','Test',1);

/*Table structure for table `ncpl_filetypes` */

DROP TABLE IF EXISTS `ncpl_filetypes`;

CREATE TABLE `ncpl_filetypes` (
  `filetype_id` int(11) unsigned NOT NULL default '0',
  `filetype_alias` varchar(255) NOT NULL default '',
  `filetype_filename` varchar(255) NOT NULL default '',
  `enabled` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`filetype_id`),
  KEY `filetype_alias` USING BTREE (`filetype_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_filetypes` */

insert into `ncpl_filetypes` values 

(0,'ALL','-',0),

(1,'commands','checkcommands.cfg',1),

(2,'contacts','contacts.cfg',1),

(3,'contactgroups','contactgroups.cfg',1),

(4,'FREE','-',0),

(5,'FREE','-',0),

(6,'hosts','hosts.cfg',1),

(7,'hostdependencies','hostdependencies.cfg',1),

(8,'hostgroupescalations','hostgroupescalations.cfg',1),

(9,'hostextinfo','hostextinfo.cfg',1),

(10,'hostgroups','hostgroups.cfg',1),

(11,'services','services.cfg',1),

(12,'servicedependencies','servicedependencies.cfg',1),

(13,'serviceescalations','serviceescalations.cfg',1),

(14,'serviceextinfo','serviceextinfo.cfg',1),

(15,'servicegroups','servicegroups.cfg',1),

(16,'timeperiods','timeperiods.cfg',1),

(17,'misccommands','misccommands.cfg',1),

(18,'resources','resources.cfg',1);

/*Table structure for table `ncpl_servers` */

DROP TABLE IF EXISTS `ncpl_servers`;

CREATE TABLE `ncpl_servers` (
  `server_name` varchar(64) NOT NULL default '',
  `server_alias` varchar(255) NOT NULL default '',
  `server_type` varchar(255) NOT NULL default '',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_name`),
  KEY `server_alias` (`server_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_servers` */

/*Table structure for table `ncpl_userlevels` */

DROP TABLE IF EXISTS `ncpl_userlevels`;

CREATE TABLE `ncpl_userlevels` (
  `userlevel_id` tinyint(1) unsigned NOT NULL default '0',
  `userlevel_alias` varchar(255) NOT NULL default '',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`userlevel_id`),
  KEY `userlevel_alias` (`userlevel_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_userlevels` */

insert into `ncpl_userlevels` values 

(1,'guest',1),

(2,'member',1),

(3,'reporter',1),

(4,'moderator',1),

(5,'admin',1),

(6,'sadmin',1);

/*Table structure for table `ncpl_users` */

DROP TABLE IF EXISTS `ncpl_users`;

CREATE TABLE `ncpl_users` (
  `user_username` varchar(64) NOT NULL default '',
  `user_password` varchar(255) NOT NULL default '',
  `user_alias` varchar(255) NOT NULL default '',
  `user_email` varchar(255) NOT NULL default '',
  `user_userlevel` tinyint(1) unsigned NOT NULL default '0',
  `enabled` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_username`),
  KEY `user_alias` (`user_alias`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `ncpl_users` */

insert into `ncpl_users` values 

('admin','21232f297a57a5a743894a0e4a801fc3','Admin','admin@localdomain',6,1);
